package cz.muni.fi.pa165.examples.currencyconvertor;

import java.math.BigDecimal;
import java.util.Currency;
import static org.junit.Assert.*;
import org.junit.Test;
import static org.mockito.Mockito.*;

public class CurrencyConvertorTest {

    @Test
    public void testConvert() {

        ExchangeRateTable exchangeRateTable = mock(ExchangeRateTable.class);
        when(exchangeRateTable.getExchangeRate(any(Currency.class))).thenReturn(BigDecimal.valueOf(28.2));
        doThrow(new UnsupportedOperationException("Not supported yet.")).when(exchangeRateTable).setExchangeRate(any(Currency.class), any(BigDecimal.class));

        CurrencyConvertor convertor = new CurrencyConvertor(exchangeRateTable);
        Currency czk = Currency.getInstance("CZK");
        BigDecimal actualResult = convertor.convert(czk, BigDecimal.valueOf(100));
        BigDecimal expectedResult = BigDecimal.valueOf(2820.0);

        assertEquals(expectedResult, actualResult);
    }
}